/*
 * Copyright (C) 2009 eXo Platform SAS.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.exoplatform.services.rest;

/**
 * Created by The eXo Platform SAS.<br/> Abstraction which "encapsulates the
 * activities of accessing resources and transferring resource representations.
 * The connectors present an abstract interface for component communication,
 * enhancing simplicity by providing a clean separation of concerns and hiding
 * the underlying implementation of resources and communication
 * mechanisms".<br/> "REST connectors provide a generic interface for accessing
 * and manipulating the value set of a resource, regardless of how the
 * membership function is defined or the type of software that is handling the
 * request."
 * 
 * @author Gennady Azarenkov
 * @version $Id: $
 */
public interface Connector
{
}
